<template lang="">
    <div class="main">
        <loading v-model:active="isLoading"
                 :can-cancel="true"
                 :is-full-page="fullPage"/>
        <ErrorPage :error_message="errors"/>

        <br>
        <input type="text" v-model="zip_name" placeholder="Enter Gdrive Folder Name"><br><br>
        
        <button @click="heyThere()">Google Login</button>

        <div class="form-control-file">
            <br>
            <div id="choosefile">
            <label for="inpfiles" class="">Select Zip or Images</label><br><br>
            <input id="inpfiles" ref="fileupload" type="file" v-on:change="file_data" multiple hidden><br>
            <small id="emailHelp" class="form-text text-muted">You can select multiple Images or one zip</small>
            </div>
        </div>
     

        <br><br>
        <div class="form-group">
        <label>Convert From:</label>
        <select name="takenfrom" v-model="convert_from">Convert To
        <option value="jpeg">JPEG</option>
        <option value="png">PNG</option>
        <option value="heic">HEIC</option>
        </select>

        <br><br>
        <label>Convert To:</label>
        <select name="format" v-model="convert_to">Convert To
        <option value="jpeg">JPEG</option>
        <option value="png">PNG</option>
        <option value="heic">HEIC</option>
        </select>
        </div><br><br>
        <button v-on:click="postMethod()" class="btn btn-info">Submit</button>

    </div>
</template>
<script>
import axios from 'axios'
import ErrorPage from './error.vue'
import Loading from 'vue-loading-overlay';
import 'vue-loading-overlay/dist/css/index.css';
import {  googleSdkLoaded  } from "vue3-google-login"



export default {
    components:{
        'ErrorPage':ErrorPage,
        Loading,
    },
    name:'LtoG',
    data(){
        return {
            files:[],
            convert_to:null,
            convert_from:null,
            send_data:[],
            zip_name:null,
            errors:[],
            isLoading:false,
            fullPage:true,
            
        }
    },
    methods: {
        validation_data(){
            this.errors = []
            if(this.files.length == 0){
                this.errors.push('File Required')
            }
            if(!this.convert_to){
                this.errors.push("Convert To Require")
            }
            if(!this.convert_from){
                this.errors.push("Convert From Require")
            }
            if(!this.zip_name){
                this.errors.push("Folder Name Require")
            }
            if(this.files.length > 0 && this.convert_to && this.convert_from && this.zip_name){
                return true
            }   

            return false

        },

        login () {

            googleSdkLoaded((google) => {
            google.accounts.oauth2.initTokenClient({
            client_id: '728619063252-gtj2nl5lj1n0khr8dq2hjp18bdnfblm7.apps.googleusercontent.com',
            scope: 'email profile openid https://www.googleapis.com/auth/drive',
            access_type: 'offline',
            callback: (response) => {
                console.log("Handle the response", response)
            }
            }).requestCode()
        })
        },

        heyThere(){
        googleSdkLoaded((google) => {
            google.accounts.oauth2.initTokenClient({
            client_id: '728619063252-gtj2nl5lj1n0khr8dq2hjp18bdnfblm7.apps.googleusercontent.com',
            scope: 'https://www.googleapis.com/auth/drive',
            access_type: 'offline',
            callback: (response) =>{
                console.log(response)},
            }).requestAccessToken();
        console.log(google)    

        })
        },

        postMethod(){


            this.errors = []

            if(this.validation_data() == false){
                return false
            }else{

            this.isLoading=true

            const formData = new FormData();

            for(let i=0; i<this.files.length; i++){
                console.log(this.files[i])
                formData.append("file",this.files[i])
            }

            formData.append("convert_to",this.convert_to)
            formData.append("convert_from",this.convert_from)

            formData.append("folder_name",this.zip_name)


            axios.post("https://image-convertor-backend.herokuapp.com/localtogdrive_api/",formData).then((response)=>{
                console.log(response)
                this.convert_to = null
                this.convert_from  = null
                this.zip_name = null
                this.isLoading=false
            }).catch((e)=>{
                console.log(e)
            })
            }
        },
        file_data(event){

            this.files = event.target.files
        }
    },
}
</script>
<style lang="">

    
</style>